Index: lib/ubasic/ubasic.c
=============================================================================
--- lib/ubasic/ubasic.c	(revision 803)
+++ lib/ubasic/ubasic.c	(working copy)
@@ -728,50 +728,111 @@
   accept_cr();
 }
 /*---------------------------------------------------------------------------*/
+/* IF-STATEMENT                                                              */
+
+static void
+endif_statement(void)
+{
+  if(if_stack_ptr > 0) {
+    accept(TOKENIZER_ENDIF);
+    accept(TOKENIZER_CR);
+    if(if_stack_ptr > 0) {
+      if_stack_ptr--;
+    } else {
+      DEBUG_PRINTF("if_statement: IF-Stack fail\n");
+      ended = 1;
+      ubasic_error = UBASIC_E_UNKNOWN_ERROR;  //besser neuer Fehler UBASIC_E_IF_STACK_EXHAUSTED,
+    }
+  } else {
+    DEBUG_PRINTF("ubasic.c: endif_statement(): endif without if-statement\n");
+    ended = 1;
+    ubasic_error = UBASIC_E_PARSE;
+  }
+}
+/*---------------------------------------------------------------------------*/
 static void
 if_statement(void)
 {
-  int r, else_cntr,endif_cntr;
+  int r, else_cntr,endif_cntr,f_nt,f_sl;
   
   accept(TOKENIZER_IF);
 
-  r = relation(); /*relation(); */
- // printf("if_statement: relation %d\n", r);
+  DEBUG_PRINTF("if_statement: get_relation\n");
+  r = relation();
+  DEBUG_PRINTF("if_statement: relation %d\n", r);
   accept(TOKENIZER_THEN);
-  if (tokenizer_token() == TOKENIZER_CR) {  
-	if(if_stack_ptr < MAX_IF_STACK_DEPTH) {
-	 if_stack[if_stack_ptr] = r;
-	 if_stack_ptr++;
-	}
+  if (tokenizer_token() == TOKENIZER_CR) {
+    if(if_stack_ptr < MAX_IF_STACK_DEPTH) {
+      if_stack[if_stack_ptr] = r;
+      if_stack_ptr++;
+    } else {
+      DEBUG_PRINTF("if_statement: IF-stack depth exceeded\n");
+      ended = 1;
+      ubasic_error = UBASIC_E_UNKNOWN_ERROR;  //besser neuer Fehler UBASIC_E_IF_STACK_EXHAUSTED,
+    }
+    DEBUG_PRINTF("if_statement: stack_ptr %d\n", if_stack_ptr);
 	  accept(TOKENIZER_CR);
 	  if(r) {
+      DEBUG_PRINTF("if_statement: result true\n");
 	  	return;
-	  }
-	  else {
+	  }else {
+      DEBUG_PRINTF("if_statement: result false\n");
+      
 	  	else_cntr=endif_cntr=0;
-		  tokenizer_next();        
-		while(((tokenizer_token() != TOKENIZER_ELSE &&  tokenizer_token() != TOKENIZER_ENDIF) 
+	  	f_nt=f_sl=0;
+
+      while(((tokenizer_token() != TOKENIZER_ELSE &&  tokenizer_token() != TOKENIZER_ENDIF) 
 		       || else_cntr || endif_cntr) && tokenizer_token() != TOKENIZER_ENDOFINPUT){
-		  if( tokenizer_token() == TOKENIZER_IF) {else_cntr+=1;endif_cntr+=1;}		    
-		  if( tokenizer_token() == TOKENIZER_ELSE) {
-			  else_cntr--;		  
-		  }
-		  if( tokenizer_token() == TOKENIZER_ENDIF)  {
-		    endif_cntr--;
+        f_nt=0;
+        if( tokenizer_token() == TOKENIZER_IF) {
+          else_cntr+=1;
+          endif_cntr+=1;
+          f_sl=0;
+DEBUG_PRINTF("IF: line %d, token %d, else %d, end %d\n", tokenizer_line_number(),tokenizer_token(),else_cntr,endif_cntr);
+        }
+        if( tokenizer_token() == TOKENIZER_THEN) {
+          f_nt=1;
+          tokenizer_next();
+DEBUG_PRINTF("THEN: line %d, token %d, else %d, end %d\n", tokenizer_line_number(),tokenizer_token(),else_cntr,endif_cntr);
+          if (tokenizer_token() != TOKENIZER_CR) { f_sl=1; }
+DEBUG_PRINTF("THEN_SL: line %d, token %d, else %d, end %d\n", tokenizer_line_number(),tokenizer_token(),else_cntr,endif_cntr);
+        }
+        if(tokenizer_token() == TOKENIZER_ELSE) {
+          else_cntr--;
+DEBUG_PRINTF("ELSE: line %d, token %d, else %d, end %d\n", tokenizer_line_number(),tokenizer_token(),else_cntr,endif_cntr);
+          if (else_cntr<0) { 
+            DEBUG_PRINTF("ubasic.c: if_statement(): if without endif-statement\n");
+            ended = 1;
+            ubasic_error = UBASIC_E_PARSE;
+            break;
+          }
+        }
+        if(!f_sl && (tokenizer_token() == TOKENIZER_ENDIF)) {
+          endif_cntr--;
+          if (endif_cntr != else_cntr) else_cntr--;
+DEBUG_PRINTF("ENDIF: line %d, token %d, else %d, end %d\n", tokenizer_line_number(),tokenizer_token(),else_cntr,endif_cntr);
+        } else {
+          if (f_sl && (tokenizer_token() == TOKENIZER_CR))  {
+            f_sl=0;
+            endif_cntr--;
             if (endif_cntr != else_cntr) else_cntr--;
-		  }    
-		  tokenizer_next();                                                         
-		 }
-	    if(tokenizer_token() == TOKENIZER_ELSE) {
-	    	return;
-		}
-	  }                                                  
-	  accept(TOKENIZER_ENDIF);
-	  accept(TOKENIZER_CR);  	              
-          if(if_stack_ptr > 0) {
-    	     if_stack_ptr--;
+DEBUG_PRINTF("ENDIF_SL: line %d, token %d, else %d, end %d\n", tokenizer_line_number(),tokenizer_token(),else_cntr,endif_cntr);
+          }else{
+            if (tokenizer_token()==TOKENIZER_ENDIF){
+              DEBUG_PRINTF("ubasic.c: if_statement(): endif in singleline if-statement\n");
+              ended = 1;
+              ubasic_error = UBASIC_E_PARSE;
+              break;
+            }
           }
+        }
+        if (!f_nt) { tokenizer_next(); }
+      }
+	    if(tokenizer_token() == TOKENIZER_ELSE) { return; }
+	  }      
+    endif_statement();
   }else {
+  // Singleline IF-Statement
 	  if(r) {
 	    statement();
 	  } else {
@@ -781,10 +842,10 @@
 		    tokenizer_token() != TOKENIZER_CR &&
 		    tokenizer_token() != TOKENIZER_ENDOFINPUT);
 	    if(tokenizer_token() == TOKENIZER_ELSE) {
-	      tokenizer_next();
+	      accept(TOKENIZER_ELSE);
 	      statement();
 	    } else if(tokenizer_token() == TOKENIZER_CR) {
-	      tokenizer_next();
+	      accept(TOKENIZER_CR);
 	    }
 	  }
   }
@@ -793,44 +854,59 @@
 static void
 else_statement(void)
 {
-  int r=0, endif_cntr;
+  int r=0, endif_cntr, f_nt;
   
   accept(TOKENIZER_ELSE);
-
   if(if_stack_ptr > 0) {
     r = if_stack[if_stack_ptr-1];
   }
- // printf("if_statement: relation %d\n", r);
-  if (tokenizer_token() == TOKENIZER_CR) {  
+  else{
+    DEBUG_PRINTF("ubasic.c: else_statement(): else without if-statement\n");
+    ended = 1;
+    ubasic_error = UBASIC_E_PARSE;
+  }
+  DEBUG_PRINTF("else_statement: relation %d\n", r);
+  
+  if (tokenizer_token() == TOKENIZER_CR) {
 	  accept(TOKENIZER_CR);
 	  if(!r) {
+      DEBUG_PRINTF("else_statement: result true\n");
 	  	return;
-	  }
-	  else {                                      
+	  } else {
+      DEBUG_PRINTF("else_statement: result false\n");
 	  	endif_cntr=0;
-		tokenizer_next();        
-		while(((tokenizer_token() != TOKENIZER_ENDIF ) 
+  		while(((tokenizer_token() != TOKENIZER_ENDIF ) 
 		       || endif_cntr) && tokenizer_token() != TOKENIZER_ENDOFINPUT){
-		  if( tokenizer_token() == TOKENIZER_IF) {endif_cntr+=1;}		    
-		  if( tokenizer_token() == TOKENIZER_ENDIF)  {
-		    endif_cntr--;
-		  }    
-		  tokenizer_next();                                                         
-		 }
-	  }                                                  
-//	  accept(TOKENIZER_ENDIF);
-//	  accept(TOKENIZER_CR);  	              
+	  	  f_nt=0;
+	  	  if( tokenizer_token() == TOKENIZER_IF) {endif_cntr+=1;}
+	  	  if( tokenizer_token() == TOKENIZER_THEN) {
+	  	    tokenizer_next();
+	  	    if (tokenizer_token() == TOKENIZER_CR) {
+	  	      f_nt=1;
+	  	    }else{
+	  	      endif_cntr--;
+        		while(tokenizer_token() != TOKENIZER_ENDIF && tokenizer_token() != TOKENIZER_CR 
+        		     && tokenizer_token() != TOKENIZER_ENDOFINPUT){
+        		  tokenizer_next();
+        		}
+            if (tokenizer_token()==TOKENIZER_ENDIF){
+              DEBUG_PRINTF("ubasic.c: else_statement(): endif in singleline if-statement\n");
+              ended = 1;
+              ubasic_error = UBASIC_E_PARSE;
+              break;
+            }
+	  	    }
+	  	  }
+		    if( tokenizer_token() == TOKENIZER_ENDIF)  { endif_cntr--; }
+		    if (!f_nt) { tokenizer_next(); }
+		  }
+	  }
+    endif_statement();
+  }else{
+    DEBUG_PRINTF("ubasic.c: else_statement(): CR after ELSE expected\n");
+    ended = 1;
+    ubasic_error = UBASIC_E_PARSE;
   }
-}
-/*---------------------------------------------------------------------------*/
-static void
-endif_statement(void)
-{
-	accept(TOKENIZER_ENDIF);
-	accept(TOKENIZER_CR);  	              
-    if(if_stack_ptr > 0) {
-    	if_stack_ptr--;
-    }
 }
 /*---------------------------------------------------------------------------*/
 
